Summary: Password propagation client
Name: passwd.cued
Version: 1.14
Release: 3
Copyright: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Provides: shadow pwdutils
Source0: passwd.cued.tar.gz
Buildroot: %{_tmppath}/%{name}-build.root
BuildPreReq: gdbm-devel openssl-devel
Patch4: passwd.cued-jpmg-uid.patch

%description
Client end of CUED password propagation system.

%package -n passwd.cued.server
Summary: Password propagation server
Copyright: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Requires: passwd.cued.admin

%description -n passwd.cued.server
Server end of CUED password propgation system.

%package -n passwd.cued.admin
Summary: Password propagation database admin tools
Copyright: CUED
Group: CUED
Packager: John Sloan <js138@eng.cam.ac.uk>
Requires: passwd.cued

%description -n passwd.cued.admin
Database administration tools for CUED password propgation system.

%prep
%setup -n passwd.cued
%patch4 -p1
%build
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/opt/passwd.cued/bin
mkdir -p $RPM_BUILD_ROOT/opt/passwd.cued/sbin
mkdir -p $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/cron.d
mkdir -p $RPM_BUILD_ROOT/bin
mkdir -p $RPM_BUILD_ROOT/etc/xinetd.d
mkdir -p $RPM_BUILD_ROOT/var/opt/passwd.cued/pwhist
mkdir -p $RPM_BUILD_ROOT/var/opt/passwd.cued/master/defaults
mkdir -p $RPM_BUILD_ROOT/usr/local/etc
mkdir -p $RPM_BUILD_ROOT/usr/local/bin
mkdir -p $RPM_BUILD_ROOT/%{_lib}/security

for i in getpasswd getpins getwinpw passpull passwd pwcmd
do
	install -m 0755 $i $RPM_BUILD_ROOT/opt/passwd.cued/bin
done

for i in batch_edit dist_keys pwpd table warn_expire tcb2pw buildpasswd \
	conv_acct pwenc pw_older tcb_showtime pwedit gredit client chpasswd \
	conv2tcb pw_older.run pw_older_warn warn_expire.run \
	warn_expire_pwd add_propagate
do
	install -m 0755 $i $RPM_BUILD_ROOT/opt/passwd.cued/sbin
done

install -m 0755 pin $RPM_BUILD_ROOT/usr/local/bin

pushd $RPM_BUILD_ROOT/opt/passwd.cued/sbin
ln -sf gredit grcat
ln -sf pwedit pwcat
popd

mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m 0600 pwhist $RPM_BUILD_ROOT/etc/logrotate.d

install -m 0600 conf $RPM_BUILD_ROOT/opt/passwd.cued/etc/conf
install -m 0600 vars/hpux $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/hpux
install -m 0600 vars/linux $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/linux
install -m 0600 vars/linux-ts $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/linux-ts
install -m 0600 vars/sol2 $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/sol2
install -m 0600 vars/sol2-nh $RPM_BUILD_ROOT/opt/passwd.cued/etc/vars/sol2-nh
install -m 0600 passwd-cued-cron $RPM_BUILD_ROOT/etc/cron.d/passwd-cued-cron
install -m 0600 passwd-cued-server-cron $RPM_BUILD_ROOT/etc/cron.d
install -m 0600 passwd.proto $RPM_BUILD_ROOT/etc/passwd.proto.example
install -m 0600 passwd.proto.lnx $RPM_BUILD_ROOT/etc/passwd.proto.lnx.example
install -m 0600 passwd.proto.local $RPM_BUILD_ROOT/etc/passwd.proto.local.example
install -m 0600 group.proto $RPM_BUILD_ROOT/etc/group.proto.example
install -m 0555 login $RPM_BUILD_ROOT/bin/login
install -m 0755 useradd $RPM_BUILD_ROOT/usr/sbin
install -m 0755 groupadd $RPM_BUILD_ROOT/usr/sbin
install -m 0400 pwpio $RPM_BUILD_ROOT/etc/xinetd.d
install -m 0755 pam/pam_pwpio.so $RPM_BUILD_ROOT/%{_lib}/security

pushd $RPM_BUILD_ROOT/usr/bin
ln -sf ../../opt/passwd.cued/bin/passwd passwd
popd

pushd $RPM_BUILD_ROOT/usr/sbin
ln -sf useradd usermod
popd

pushd $RPM_BUILD_ROOT/usr/local/etc
ln -sf /var/opt/passwd.cued uids
popd

%files
/opt/passwd.cued/bin/getpasswd
/opt/passwd.cued/bin/getwinpw
/opt/passwd.cued/bin/getpins
/opt/passwd.cued/bin/passwd
/opt/passwd.cued/bin/passpull
/opt/passwd.cued/bin/pwcmd
%config /etc/cron.d/passwd-cued-cron
/etc/passwd.proto.example
/etc/passwd.proto.lnx.example
/etc/passwd.proto.local.example
/etc/group.proto.example
/usr/bin/passwd
/usr/sbin/groupadd
/usr/sbin/useradd
/usr/sbin/usermod
/bin/login
%config /opt/passwd.cued/etc/conf
/usr/local/bin/pin
/%{_lib}/security/pam_pwpio.so

%files -n passwd.cued.server
%config /opt/passwd.cued/etc/vars/hpux
%config /opt/passwd.cued/etc/vars/linux
%config /opt/passwd.cued/etc/vars/linux-ts
%config /opt/passwd.cued/etc/vars/sol2
%config /opt/passwd.cued/etc/vars/sol2-nh
/opt/passwd.cued/sbin/pwenc
/opt/passwd.cued/sbin/pwpd
/opt/passwd.cued/sbin/pw_older
%config /opt/passwd.cued/sbin/pw_older.run
%config /opt/passwd.cued/sbin/pw_older_warn
/opt/passwd.cued/sbin/table
/opt/passwd.cued/sbin/tcb_showtime
/opt/passwd.cued/sbin/warn_expire
%config /opt/passwd.cued/sbin/warn_expire.run
%config /opt/passwd.cued/sbin/warn_expire_pwd
/opt/passwd.cued/sbin/tcb2pw
/etc/xinetd.d/pwpio
/etc/cron.d/passwd-cued-server-cron
/usr/local/etc/uids

%files -n passwd.cued.admin
/opt/passwd.cued/sbin/add_propagate
/opt/passwd.cued/sbin/batch_edit
/opt/passwd.cued/sbin/buildpasswd
/opt/passwd.cued/sbin/chpasswd
/opt/passwd.cued/sbin/client
/opt/passwd.cued/sbin/conv2tcb
/opt/passwd.cued/sbin/conv_acct
/opt/passwd.cued/sbin/dist_keys
/opt/passwd.cued/sbin/grcat
/opt/passwd.cued/sbin/gredit
/opt/passwd.cued/sbin/pwcat
/opt/passwd.cued/sbin/pwedit
/etc/logrotate.d/pwhist
/var/opt/passwd.cued/pwhist

%post
cat /etc/services | grep -v pwpio >> /etc/services.new
cat >>/etc/services.new <<EOF
pwpio		619/tcp				# CUED passwd propagation
EOF
mv /etc/services.new /etc/services
cat /etc/pam.d/sshd | grep -v pam_pwpio >> /etc/pam.d/sshd.new
cat >>/etc/pam.d/sshd.new <<EOF
password required       pam_pwpio.so    try_first_pass use_authtok
EOF
mv /etc/pam.d/sshd.new /etc/pam.d/sshd
chmod 644 /etc/pam.d/sshd
